=== debian/changelog ===
bitcoin-knots (29.1.knots20250903-1) unstable; urgency=medium

  * Initial release. Closes: #1106648

 -- Léo Haf <leo@haf.ovh>  Mon, 06 Oct 2025 12:22:21 +0200
