=== debian/control ===
Source: bitcoin-knots
Section: utils
Priority: optional
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders: Léo Haf <leo@haf.ovh>,
           Soren Stoutner <soren@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 pkgconf,
 python3,
 libevent-dev,
 libboost-dev,
 libsqlite3-dev,
 libminiupnpc-dev,
 systemtap-sdt-dev,
 libzmq3-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 librsvg2-bin,
 imagemagick,
 libqrencode-dev
Standards-Version: 4.7.2
Homepage: https://bitcoinknots.org
Vcs-Git: https://salsa.debian.org/cryptocoin-team/bitcoin-knots.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/bitcoin-knots

Package: bitcoin-knots
Architecture: any
# The postinst script requires adduser.
Depends: ${misc:Depends},
 ${shlibs:Depends},
 adduser
Description: enhanced Bitcoin node/wallet software
 Bitcoin Knots is the original Bitcoin client and it builds the
 backbone of the network.
 It downloads and, by default, stores the entire history of
 Bitcoin transactions, which requires a few hundred gigabytes of disk space.
 Depending on the speed of your computer and network connection,
 the synchronization process can take anywhere from a few
 hours to a day or more.

Package: bitcoin-knots-gui
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: enhanced Bitcoin node/wallet software with GUI
 Bitcoin Knots (with GUI) is the original Bitcoin client and it builds the
 backbone of the network.
 It downloads and, by default, stores the entire history of
 Bitcoin transactions, which requires a few hundred gigabytes of disk space.
 Depending on the speed of your computer and network connection,
 the synchronization process can take anywhere from a few
 hours to a day or more.
