=== debian/tests/control ===
Tests: functional
Depends: @,
         python3-zmq
Restrictions: needs-root

Tests: util
Depends: @,
         python3
