=== debian/watch ===
Version: 5

Source: https://github.com/bitcoinknots/bitcoin/tags
Matching-Pattern: .*/v?(\d.*)@ARCHIVE_EXT@
